(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@grapecity/inputman'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@grapecity/inputman.angular', ['exports', '@angular/core', '@grapecity/inputman', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory((global.grapecity = global.grapecity || {}, global.grapecity.inputman = global.grapecity.inputman || {}, global.grapecity.inputman.angular = {}), global.ng.core, global.inputman, global.ng.common, global.ng.forms));
}(this, (function (exports, core, inputman, common, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    function Property(setter, getter, isPramArr, supportWithinConfig, order) {
        var saveToTargetProDic = function (target, propertyName) {
            var methods = {
                setter: setter,
                getter: getter,
                isPramArr: isPramArr,
                supportWithinConfig: (typeof supportWithinConfig === "boolean") ? supportWithinConfig : true,
                order: (typeof order === "number") ? order : -1
            };
            if (!target.propDic) {
                target.propDic = {};
            }
            target.propDic[propertyName] = methods;
        };
        return saveToTargetProDic;
    }
    var isEmpty = function (value) {
        return value === undefined || value === null || value === "";
    };
    var ɵ0 = isEmpty;
    var getMethodPrefix = function (type) {
        if (type === exports.MethodType.getter) {
            return "get";
        }
        else if (type === exports.MethodType.setter) {
            return "set";
        }
    };
    var ɵ1 = getMethodPrefix;

    (function (MethodType) {
        MethodType[MethodType["getter"] = 0] = "getter";
        MethodType[MethodType["setter"] = 1] = "setter";
    })(exports.MethodType || (exports.MethodType = {}));
    function provideParent(component) {
        return { provide: GcComponents, useExisting: core.forwardRef(function () { return component; }) };
    }
    var GcComponents = /** @class */ (function () {
        function GcComponents(ref) {
            this.onInitialized = new core.EventEmitter();
            this._container = ref.nativeElement;
        }
        GcComponents.prototype.ngOnChanges = function (changes) {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            Object.keys(changes).forEach(function (key) {
                var currentValue = changes[key].currentValue;
                _this.setValueToIMControl(key, currentValue);
            });
        };
        GcComponents.prototype.setValueToIMControl = function (key, value) {
            if (value === undefined) {
                return;
            }
            var setter = this.tryGetPropertyOperator(key, exports.MethodType.setter);
            if (this.hasRealMethod(setter)) {
                if (this.propDic && this.propDic[key] && this.propDic[key].isPramArr === true) {
                    this._imCtrl[setter].apply(this._imCtrl, value);
                }
                else {
                    this._imCtrl[setter](value);
                }
            }
        };
        GcComponents.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.initGcComponent();
            if (typeof this._imCtrl === 'object') {
                this.onInitialized.emit(this._imCtrl);
            }
            this.bindEvent();
            if (this.propDic) {
                var unSupportWithinConfigProps = Object.keys(this.propDic).filter(function (p) { return _this.propDic[p] && _this.propDic[p].supportWithinConfig === false; });
                unSupportWithinConfigProps.sort(function (p1, p2) {
                    return _this.propDic[p1].order - _this.propDic[p2].order;
                });
                unSupportWithinConfigProps.forEach(function (p) {
                    _this.setValueToIMControl(p, _this[p]);
                });
            }
        };
        GcComponents.prototype.tryGetPropertyOperator = function (propertyName, methodType) {
            var method = "";
            if (this.propDic && this.propDic[propertyName]) {
                method = methodType === exports.MethodType.getter ? this.propDic[propertyName].getter : this.propDic[propertyName].setter;
                if (!isEmpty(method)) {
                    return method;
                }
            }
            return getMethodPrefix(methodType) + propertyName[0].toUpperCase() + propertyName.slice(1);
        };
        GcComponents.prototype.hasRealMethod = function (methodName) {
            return this._imCtrl && typeof this._imCtrl[methodName] === "function";
        };
        GcComponents.prototype.getNestedIMControl = function () {
            return this._imCtrl;
        };
        __decorate([
            core.Output()
        ], GcComponents.prototype, "onInitialized", void 0);
        return GcComponents;
    }());
    var GcInputManBaseComponent = /** @class */ (function (_super) {
        __extends(GcInputManBaseComponent, _super);
        function GcInputManBaseComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.onEditStatusChanged = new core.EventEmitter();
            _this.onInvalidInput = new core.EventEmitter();
            _this.onKeyExit = new core.EventEmitter();
            _this.onTextChanged = new core.EventEmitter();
            _this.onInput = new core.EventEmitter();
            _this.onFocusOut = new core.EventEmitter();
            _this.onKeyDown = new core.EventEmitter();
            _this.onKeyUp = new core.EventEmitter();
            _this.onSyncValueToOriginalInput = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.textChange = new core.EventEmitter();
            return _this;
        }
        GcInputManBaseComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            this._imCtrl.onEditStatusChanged(function (s) { _this.onEditStatusChanged.emit(s); });
            this._imCtrl.onInvalidInput(function (s) { _this.onInvalidInput.emit(s); });
            this._imCtrl.onKeyExit(function (s) { _this.onKeyExit.emit(s); });
            this._imCtrl.onTextChanged(function (s) { _this.onTextChanged.emit(s); _this.textChange.emit(s.getText()); });
            this._imCtrl.onInput(function (s) { _this.onInput.emit(s); });
            this._imCtrl.onFocusOut(function (s, e) { _this.onFocusOut.emit({ sender: s, eArgs: e }); });
            this._imCtrl.onKeyDown(function (s, e) { _this.onKeyDown.emit({ sender: s, eArgs: e }); });
            this._imCtrl.onKeyUp(function (s, e) { _this.onKeyUp.emit({ sender: s, eArgs: e }); });
            this._imCtrl.onSyncValueToOriginalInput(function (v, e) { _this.onSyncValueToOriginalInput.emit({ value: v, element: e }); });
        };
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "visible", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "enabled", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "readOnly", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "exitOnLeftRightKey", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "editMode", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "watermarkDisplayNullText", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "watermarkNullText", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "acceptsCrlf", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "useClipboard", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "exitOnEnterKey", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "container", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "autoDropDown", void 0);
        __decorate([
            core.Input()
        ], GcInputManBaseComponent.prototype, "dropDownButtonVisible", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onEditStatusChanged", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onInvalidInput", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onKeyExit", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onTextChanged", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onInput", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onFocusOut", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onKeyDown", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onKeyUp", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "onSyncValueToOriginalInput", void 0);
        __decorate([
            core.Output()
        ], GcInputManBaseComponent.prototype, "textChange", void 0);
        return GcInputManBaseComponent;
    }(GcComponents));
    var GcTextBoxComponent = /** @class */ (function (_super) {
        __extends(GcTextBoxComponent, _super);
        function GcTextBoxComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.onIMEReadingStringOutput = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.imeReadingStringChange = new core.EventEmitter();
            return _this;
        }
        GcTextBoxComponent_1 = GcTextBoxComponent;
        GcTextBoxComponent.prototype.initGcComponent = function () {
            var input = document.createElement("input");
            this._container.appendChild(input);
            this["IMEReadingStringAppend"] = this.imeReadingStringAppend;
            this["IMEReadingStringKanaMode"] = this.imeReadingStringKanaMode;
            this["IMEReadingStringEnableAlphabetReadingMapping"] = this.imeReadingStringEnableAlphabetReadingMapping;
            this._imCtrl = new inputman.InputMan.GcTextBox(input, this);
        };
        GcTextBoxComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            _super.prototype.bindEvent.call(this);
            this._imCtrl.onIMEReadingStringOutput(function (s, e) {
                _this.onIMEReadingStringOutput.emit({ sender: s, eArgs: e });
                _this.imeReadingStringChange.emit(s.getIMEReadingString());
            });
        };
        var GcTextBoxComponent_1;
        GcTextBoxComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "autoConvert", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "ellipsisString", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "ellipsis", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "format", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "lengthAsByte", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "maxLength", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "passwordChar", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "text", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "useSystemPasswordChar", void 0);
        __decorate([
            core.Input(),
            Property("setIMEReadingStringAppend")
        ], GcTextBoxComponent.prototype, "imeReadingStringAppend", void 0);
        __decorate([
            core.Input(),
            Property("setIMEReadingStringKanaMode")
        ], GcTextBoxComponent.prototype, "imeReadingStringKanaMode", void 0);
        __decorate([
            core.Input(),
            Property("setIMEReadingStringEnableAlphabetReadingMapping")
        ], GcTextBoxComponent.prototype, "imeReadingStringEnableAlphabetReadingMapping", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "exitOnLastChar", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "highlightText", void 0);
        __decorate([
            core.Input()
        ], GcTextBoxComponent.prototype, "imeReadingString", void 0);
        __decorate([
            core.Output()
        ], GcTextBoxComponent.prototype, "onIMEReadingStringOutput", void 0);
        __decorate([
            core.Output()
        ], GcTextBoxComponent.prototype, "imeReadingStringChange", void 0);
        GcTextBoxComponent = GcTextBoxComponent_1 = __decorate([
            core.Component({
                selector: 'gc-text-box',
                template: "",
                providers: [provideParent(GcTextBoxComponent_1)]
            })
        ], GcTextBoxComponent);
        return GcTextBoxComponent;
    }(GcInputManBaseComponent));
    var GcNumberComponent = /** @class */ (function (_super) {
        __extends(GcNumberComponent, _super);
        function GcNumberComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.onSpinDown = new core.EventEmitter();
            _this.onSpinUp = new core.EventEmitter();
            _this.onInvalidRange = new core.EventEmitter();
            _this.onValueChanged = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.valueChange = new core.EventEmitter();
            return _this;
        }
        GcNumberComponent_1 = GcNumberComponent;
        GcNumberComponent.prototype.initGcComponent = function () {
            var element = document.createElement('input');
            this._container.appendChild(element);
            this._imCtrl = new inputman.InputMan.GcNumber(element, this);
        };
        GcNumberComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            _super.prototype.bindEvent.call(this);
            this._imCtrl.onSpinDown(function (s) { _this.onSpinDown.emit(s); });
            this._imCtrl.onSpinUp(function (s) { _this.onSpinUp.emit(s); });
            this._imCtrl.onInvalidRange(function (s) { _this.onInvalidRange.emit(s); });
            this._imCtrl.onValueChanged(function (s) {
                _this.onValueChanged.emit(s);
                _this.valueChange.emit(s.getValue());
            });
        };
        GcNumberComponent.prototype.clear = function () {
            return this._imCtrl.clear();
        };
        var GcNumberComponent_1;
        GcNumberComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "value", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "text", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "watermarkZeroText", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "formatDigit", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "displayPositivePrefix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "displayFormatDigit", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "maxValue", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "minValue", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "positivePrefix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "positiveSuffix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "displayPositiveSuffix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "negativePrefix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "displayNegativePrefix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "negativeSuffix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "displayNegativeSuffix", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "valueSign", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "adjustValueOnFocus", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "allowDeleteToNull", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "clearAction", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "acceptsDecimal", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "currencySymbol", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "decimalPoint", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "maxMinBehavior", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "separator", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "watermarkDisplayZeroText", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "highlightText", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "allowSpin", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "spinOnKeys", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "spinWrap", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "showSpinButton", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "spinButtonPosition", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "showNumericPad", void 0);
        __decorate([
            core.Input()
        ], GcNumberComponent.prototype, "numericPadPosition", void 0);
        __decorate([
            core.Output()
        ], GcNumberComponent.prototype, "onSpinDown", void 0);
        __decorate([
            core.Output()
        ], GcNumberComponent.prototype, "onSpinUp", void 0);
        __decorate([
            core.Output()
        ], GcNumberComponent.prototype, "onInvalidRange", void 0);
        __decorate([
            core.Output()
        ], GcNumberComponent.prototype, "onValueChanged", void 0);
        __decorate([
            core.Output()
        ], GcNumberComponent.prototype, "valueChange", void 0);
        GcNumberComponent = GcNumberComponent_1 = __decorate([
            core.Component({
                selector: 'gc-number',
                template: "",
                providers: [provideParent(GcNumberComponent_1)]
            })
        ], GcNumberComponent);
        return GcNumberComponent;
    }(GcInputManBaseComponent));
    var GcDateTimeComponent = /** @class */ (function (_super) {
        __extends(GcDateTimeComponent, _super);
        function GcDateTimeComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.onSpinDown = new core.EventEmitter();
            _this.onSpinUp = new core.EventEmitter();
            _this.onInvalidRange = new core.EventEmitter();
            _this.onInvalidValue = new core.EventEmitter();
            _this.onNumberChanged = new core.EventEmitter();
            _this.onValueChanged = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.numberChange = new core.EventEmitter();
            _this.valueChange = new core.EventEmitter();
            return _this;
        }
        GcDateTimeComponent_1 = GcDateTimeComponent;
        GcDateTimeComponent.prototype.initGcComponent = function () {
            var element = document.createElement('input');
            this._container.appendChild(element);
            this._imCtrl = new inputman.InputMan.GcDateTime(element, this);
        };
        GcDateTimeComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            _super.prototype.bindEvent.call(this);
            this._imCtrl.onSpinDown(function (s) { _this.onSpinDown.emit(s); });
            this._imCtrl.onSpinUp(function (s) { _this.onSpinUp.emit(s); });
            this._imCtrl.onInvalidRange(function (s) { _this.onInvalidRange.emit(s); });
            this._imCtrl.onInvalidValue(function (s) { _this.onInvalidValue.emit(s); });
            this._imCtrl.onNumberChanged(function (s) {
                _this.onNumberChanged.emit(s);
                _this.numberChange.emit(s.getNumber());
            });
            this._imCtrl.onValueChanged(function (s) {
                _this.onValueChanged.emit(s);
                _this.valueChange.emit(s.getValue());
            });
        };
        var GcDateTimeComponent_1;
        GcDateTimeComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "text", void 0);
        __decorate([
            Property("", "", false, false),
            core.Input()
        ], GcDateTimeComponent.prototype, "number", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "maxDate", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "minDate", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "formatPattern", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "spinIncrement", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "spinOnKeys", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "spinWrap", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "allowSpin", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "displayFormatPattern", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "watermarkEmptyEraText", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "promptChar", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "AMDesignator", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "PMDesignator", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "twoDigitYearMax", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "hour12Mode", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "tabAction", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "maxMinBehavior", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "midnightAs24", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "showLiterals", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "adjustValueOnFocus", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "useTwoDigitYearMax", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "validateMode", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "clipContent", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "value", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "watermarkDisplayEmptyEraText", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "dropDownConfig", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "exitOnLastChar", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "highlightText", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "showSpinButton", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "spinButtonPosition", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "showDropDownButton", void 0);
        __decorate([
            core.Input()
        ], GcDateTimeComponent.prototype, "dropDownButtonAlignment", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "onSpinDown", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "onSpinUp", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "onInvalidRange", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "onInvalidValue", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "onNumberChanged", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "onValueChanged", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "numberChange", void 0);
        __decorate([
            core.Output()
        ], GcDateTimeComponent.prototype, "valueChange", void 0);
        GcDateTimeComponent = GcDateTimeComponent_1 = __decorate([
            core.Component({
                selector: 'gc-datetime',
                template: "",
                providers: [provideParent(GcDateTimeComponent_1)]
            })
        ], GcDateTimeComponent);
        return GcDateTimeComponent;
    }(GcInputManBaseComponent));
    var GcCalendarComponent = /** @class */ (function (_super) {
        __extends(GcCalendarComponent, _super);
        function GcCalendarComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.onClickDate = new core.EventEmitter();
            _this.onScrolled = new core.EventEmitter();
            _this.onFocusDateChanged = new core.EventEmitter();
            _this.onSelectedDateChanged = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.focusDateChange = new core.EventEmitter();
            _this.selectedDateChange = new core.EventEmitter();
            return _this;
        }
        GcCalendarComponent.prototype.initGcComponent = function () {
            var element = document.createElement('div');
            this._container.appendChild(element);
            if (Array.isArray(this.calendarDimensions)) {
                this.calendarDimensions = {
                    width: this.calendarDimensions[0],
                    height: this.calendarDimensions[1]
                };
            }
            this._imCtrl = new inputman.InputMan.GcCalendar(element, this);
        };
        GcCalendarComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            this._imCtrl.onClickDate(function (s) { _this.onClickDate.emit(s); });
            this._imCtrl.onScrolled(function (s) { _this.onScrolled.emit(s); });
            this._imCtrl.onFocusDateChanged(function (s) {
                _this.onFocusDateChanged.emit(s);
                _this.focusDateChange.emit(s.getFocusDate());
            });
            this._imCtrl.onSelectedDateChanged(function (s) {
                _this.onSelectedDateChanged.emit(s);
                _this.selectedDateChange.emit(s.getSelectedDate());
            });
        };
        GcCalendarComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "visible", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "maxSelectionCount", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "selectionMode", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "selectedDate", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "enabled", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "weekTitleSelect", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "weekNumberSelect", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "focusDate", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "maxDate", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "minDate", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "allowSelection", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "emptyRows", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "firstDayOfWeek", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "firstFiscalMonth", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "firstMonthInView", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "yearMonthFormat", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "headerFormat", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showZoomButton", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showRokuyou", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showHeader", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showToday", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showWeekNumber", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showTrailing", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "calendarYear", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "showNavigator", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "navigatorOrientation", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "overrideTipText", void 0);
        __decorate([
            core.Input()
        ], GcCalendarComponent.prototype, "calendarType", void 0);
        __decorate([
            Property("setCalendarDimensions", "", true),
            core.Input()
        ], GcCalendarComponent.prototype, "calendarDimensions", void 0);
        __decorate([
            core.Output()
        ], GcCalendarComponent.prototype, "onClickDate", void 0);
        __decorate([
            core.Output()
        ], GcCalendarComponent.prototype, "onScrolled", void 0);
        __decorate([
            core.Output()
        ], GcCalendarComponent.prototype, "onFocusDateChanged", void 0);
        __decorate([
            core.Output()
        ], GcCalendarComponent.prototype, "onSelectedDateChanged", void 0);
        __decorate([
            core.Output()
        ], GcCalendarComponent.prototype, "focusDateChange", void 0);
        __decorate([
            core.Output()
        ], GcCalendarComponent.prototype, "selectedDateChange", void 0);
        GcCalendarComponent = __decorate([
            core.Component({
                selector: 'gc-calendar',
                template: ""
            })
        ], GcCalendarComponent);
        return GcCalendarComponent;
    }(GcComponents));
    var GcMaskComponent = /** @class */ (function (_super) {
        __extends(GcMaskComponent, _super);
        function GcMaskComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.onTextChanging = new core.EventEmitter();
            _this.onSpinDown = new core.EventEmitter();
            _this.onSpinUp = new core.EventEmitter();
            _this.onValueChanged = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.valueChange = new core.EventEmitter();
            _this.valueIsFullChange = new core.EventEmitter();
            return _this;
        }
        GcMaskComponent_1 = GcMaskComponent;
        GcMaskComponent.prototype.initGcComponent = function () {
            var input = document.createElement('input');
            this._container.appendChild(input);
            this._imCtrl = new inputman.InputMan.GcMask(input, this);
        };
        GcMaskComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            _super.prototype.bindEvent.call(this);
            this._imCtrl.onInput(function (s) {
                _this.valueIsFullChange.emit(s.getValueIsFull());
            });
            this._imCtrl.onTextChanging(function (s, e) { _this.onTextChanging.emit({ sender: s, eArgs: e }); });
            this._imCtrl.onSpinDown(function (s) { _this.onSpinDown.emit(s); });
            this._imCtrl.onSpinUp(function (s) { _this.onSpinUp.emit(s); });
            this._imCtrl.onValueChanged(function (s) {
                _this.onValueChanged.emit(s);
                _this.valueChange.emit(s.getValue());
                _this.valueIsFullChange.emit(s.getValueIsFull());
            });
        };
        var GcMaskComponent_1;
        GcMaskComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "autoConvert", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "value", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "formatPattern", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "promptChar", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "showLiterals", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "tabAction", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "text", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "clipContent", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "allowSpin", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "exitOnLastChar", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "highlightText", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "showSpinButton", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "spinButtonPosition", void 0);
        __decorate([
            core.Input()
        ], GcMaskComponent.prototype, "valueIsFull", void 0);
        __decorate([
            core.Output()
        ], GcMaskComponent.prototype, "onTextChanging", void 0);
        __decorate([
            core.Output()
        ], GcMaskComponent.prototype, "onSpinDown", void 0);
        __decorate([
            core.Output()
        ], GcMaskComponent.prototype, "onSpinUp", void 0);
        __decorate([
            core.Output()
        ], GcMaskComponent.prototype, "onValueChanged", void 0);
        __decorate([
            core.Output()
        ], GcMaskComponent.prototype, "valueChange", void 0);
        __decorate([
            core.Output()
        ], GcMaskComponent.prototype, "valueIsFullChange", void 0);
        GcMaskComponent = GcMaskComponent_1 = __decorate([
            core.Component({
                selector: 'gc-mask',
                template: "",
                providers: [provideParent(GcMaskComponent_1)]
            })
        ], GcMaskComponent);
        return GcMaskComponent;
    }(GcInputManBaseComponent));
    var GcListBoxColumnComponent = /** @class */ (function () {
        function GcListBoxColumnComponent() {
        }
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "name", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "label", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "width", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "isValuePath", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "visible", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "clickSort", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "contentAlignment", void 0);
        __decorate([
            core.Input()
        ], GcListBoxColumnComponent.prototype, "headerAlignment", void 0);
        GcListBoxColumnComponent = __decorate([
            core.Component({
                selector: 'gc-list-box-column',
                template: ""
            })
        ], GcListBoxColumnComponent);
        return GcListBoxColumnComponent;
    }());
    var GcListBoxComponent = /** @class */ (function (_super) {
        __extends(GcListBoxComponent, _super);
        function GcListBoxComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.checkedChanged = new core.EventEmitter();
            _this.selectedChanged = new core.EventEmitter();
            _this.focusedChanged = new core.EventEmitter();
            _this.itemClick = new core.EventEmitter();
            _this.loadComplete = new core.EventEmitter();
            _this.itemsChanged = new core.EventEmitter();
            _this.selectedIndexChange = new core.EventEmitter();
            _this.checkedIndexChange = new core.EventEmitter();
            _this.selectedIndicesChange = new core.EventEmitter();
            _this.checkedIndicesChange = new core.EventEmitter();
            return _this;
        }
        GcListBoxComponent.prototype.initGcComponent = function () {
            var _this = this;
            if (this.columnComponents && this.columnComponents.length > 0) {
                this.columns = [];
                this.columnComponents.forEach(function (column) {
                    _this.columns.push({
                        name: column.name,
                        label: column.label,
                        width: column.width,
                        isValuePath: column.isValuePath,
                        visible: column.visible,
                        clickSort: column.clickSort,
                        contentAlignment: column.contentAlignment,
                        headerAlignment: column.headerAlignment
                    });
                });
            }
            var element = document.createElement('select');
            this._container.appendChild(element);
            this._imCtrl = new inputman.InputMan.GcListBox(element, this);
        };
        GcListBoxComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            this._imCtrl.addEventListener(inputman.InputMan.GcListBoxEvent.CheckedChanged, function (eventArgs) {
                _this.checkedChanged.emit(eventArgs);
                _this.checkedIndexChange.emit(_this._imCtrl.getCheckedIndices()[0]);
                _this.checkedIndicesChange.emit(_this._imCtrl.getCheckedIndices());
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcListBoxEvent.SelectedChanged, function (eventArgs) {
                _this.selectedChanged.emit(eventArgs);
                _this.selectedIndexChange.emit(_this._imCtrl.getSelectedIndex());
                _this.selectedIndicesChange.emit(_this._imCtrl.getSelectedIndices());
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcListBoxEvent.FocusedChanged, function (eventArgs) {
                _this.focusedChanged.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcListBoxEvent.ItemClick, function (sender, eventArgs) {
                _this.itemClick.emit({ sender: sender, eArgs: eventArgs });
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcListBoxEvent.LoadComplete, function (eventArgs) {
                _this.loadComplete.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcListBoxEvent.ItemsChanged, function (eventArgs) {
                _this.itemsChanged.emit(eventArgs);
            });
        };
        GcListBoxComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "items", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "columns", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "virtualMode", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "allowResize", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "selectionMode", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcListBoxComponent.prototype, "selectedIndex", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcListBoxComponent.prototype, "checkedIndex", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcListBoxComponent.prototype, "selectedIndices", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcListBoxComponent.prototype, "checkedIndices", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "allowColumnResize", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "overflow", void 0);
        __decorate([
            Property("resizeWidth"),
            core.Input()
        ], GcListBoxComponent.prototype, "width", void 0);
        __decorate([
            Property("resizeHeight"),
            core.Input()
        ], GcListBoxComponent.prototype, "height", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "itemHeight", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "checkOnClick", void 0);
        __decorate([
            Property('setVisibleItemCount'),
            core.Input()
        ], GcListBoxComponent.prototype, "visibleItems", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "visible", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "enabled", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "multiColumn", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "colHeaderHeight", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "showHeader", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "valueMemberPath", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "displayMemberPath", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "showCheckBox", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "itemTemplate", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "headerTemplate", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "footerTemplate", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "load", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "pageSize", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "generatingItem", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "selectTemplate", void 0);
        __decorate([
            core.Input()
        ], GcListBoxComponent.prototype, "formatItem", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "checkedChanged", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "selectedChanged", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "focusedChanged", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "itemClick", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "loadComplete", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "itemsChanged", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "selectedIndexChange", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "checkedIndexChange", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "selectedIndicesChange", void 0);
        __decorate([
            core.Output()
        ], GcListBoxComponent.prototype, "checkedIndicesChange", void 0);
        __decorate([
            core.ContentChildren(GcListBoxColumnComponent)
        ], GcListBoxComponent.prototype, "columnComponents", void 0);
        GcListBoxComponent = __decorate([
            core.Component({
                selector: 'gc-list-box',
                template: ""
            })
        ], GcListBoxComponent);
        return GcListBoxComponent;
    }(GcComponents));
    var GcComboBoxColumnComponent = /** @class */ (function () {
        function GcComboBoxColumnComponent() {
        }
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "name", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "label", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "width", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "isValuePath", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "visible", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "clickSort", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "contentAlignment", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxColumnComponent.prototype, "headerAlignment", void 0);
        GcComboBoxColumnComponent = __decorate([
            core.Component({
                selector: 'gc-combo-box-column',
                template: ""
            })
        ], GcComboBoxColumnComponent);
        return GcComboBoxColumnComponent;
    }());
    var GcComboBoxComponent = /** @class */ (function (_super) {
        __extends(GcComboBoxComponent, _super);
        function GcComboBoxComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.selectedChanged = new core.EventEmitter();
            _this.checkedChanged = new core.EventEmitter();
            _this.dropDownClosed = new core.EventEmitter();
            _this.dropDownOpened = new core.EventEmitter();
            _this.textChanged = new core.EventEmitter();
            _this.spinDown = new core.EventEmitter();
            _this.spinUp = new core.EventEmitter();
            _this.itemsChanged = new core.EventEmitter();
            _this.itemsChange = new core.EventEmitter();
            _this.selectedValueChange = new core.EventEmitter();
            _this.selectedIndexChange = new core.EventEmitter();
            _this.checkedValuesChange = new core.EventEmitter();
            _this.selectedItemChange = new core.EventEmitter();
            _this.checkedItemsChange = new core.EventEmitter();
            _this.checkedIndicesChange = new core.EventEmitter();
            return _this;
        }
        GcComboBoxComponent_1 = GcComboBoxComponent;
        GcComboBoxComponent.prototype.initGcComponent = function () {
            var _this = this;
            if (this.columnComponents && this.columnComponents.length > 0) {
                this.columns = [];
                this.columnComponents.forEach(function (column) {
                    _this.columns.push({
                        name: column.name,
                        label: column.label,
                        width: column.width,
                        isValuePath: column.isValuePath,
                        visible: column.visible,
                        clickSort: column.clickSort,
                        contentAlignment: column.contentAlignment,
                        headerAlignment: column.headerAlignment
                    });
                });
            }
            var element = document.createElement('select');
            this._container.appendChild(element);
            this._imCtrl = new inputman.InputMan.GcComboBox(element, this);
        };
        GcComboBoxComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.SelectedChanged, function (eventArgs) {
                _this.selectedChanged.emit(eventArgs);
                _this.selectedValueChange.emit(_this._imCtrl.getSelectedValue());
                _this.selectedIndexChange.emit(_this._imCtrl.getSelectedIndex());
                _this.selectedItemChange.emit(_this._imCtrl.getSelectedItem());
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.CheckedChanged, function (eventArgs) {
                _this.checkedChanged.emit(eventArgs);
                _this.checkedValuesChange.emit(_this._imCtrl.getCheckedValues());
                _this.checkedItemsChange.emit(_this._imCtrl.getCheckedItems());
                _this.checkedIndicesChange.emit(_this._imCtrl.getCheckedIndices());
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.DropDownClosed, function (eventArgs) {
                _this.dropDownClosed.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.DropDownOpened, function (eventArgs) {
                _this.dropDownOpened.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.TextChanged, function (eventArgs) {
                _this.textChanged.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.SpinDown, function (eventArgs) {
                _this.spinDown.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.SpinUp, function (eventArgs) {
                _this.spinUp.emit(eventArgs);
            });
            this._imCtrl.addEventListener(inputman.InputMan.GcComboBoxEvent.ItemsChanged, function (eventArgs) {
                _this.itemsChanged.emit(eventArgs);
                _this.itemsChange.emit(_this._imCtrl.getItems());
            });
        };
        var GcComboBoxComponent_1;
        GcComboBoxComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "items", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcComboBoxComponent.prototype, "selectedValue", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "allowDropDownResize", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "readOnly", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "autoSelect", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcComboBoxComponent.prototype, "selectedIndex", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "autoFilter", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "visible", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "enabled", void 0);
        __decorate([
            Property("setEditable"),
            core.Input()
        ], GcComboBoxComponent.prototype, "isEditable", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "watermarkDisplayNullText", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "watermarkNullText", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "highlightText", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "exitOnEnterKey", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "useClipboard", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "acceptsCrlf", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "ellipsis", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "ellipsisString", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "exitOnLeftRightKey", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "editMode", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcComboBoxComponent.prototype, "checkedValues", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcComboBoxComponent.prototype, "selectedItem", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcComboBoxComponent.prototype, "checkedItems", void 0);
        __decorate([
            core.Input(),
            Property("", "", false, false)
        ], GcComboBoxComponent.prototype, "checkedIndices", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "showDropDownButton", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "dropDownButtonPosition", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "showSpinButton", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "spinButtonPosition", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "dropDownWidth", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "dropDownHeight", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "minPrefixLength", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "isMultiSelect", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "dropDownOverflow", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "visibleItems", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "itemHeight", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "columns", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "showHeader", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "valueMemberPath", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "displayMemberPath", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "checkOnClick", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "itemTemplate", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "headerTemplate", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "footerTemplate", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "load", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "pageSize", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "virtualMode", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "generatingItem", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "selectTemplate", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "formatItem", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "allowColumnResize", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "colHeaderHeight", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "container", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "autoDropDown", void 0);
        __decorate([
            core.Input()
        ], GcComboBoxComponent.prototype, "dropDownButtonVisible", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "selectedChanged", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "checkedChanged", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "dropDownClosed", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "dropDownOpened", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "textChanged", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "spinDown", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "spinUp", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "itemsChanged", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "itemsChange", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "selectedValueChange", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "selectedIndexChange", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "checkedValuesChange", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "selectedItemChange", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "checkedItemsChange", void 0);
        __decorate([
            core.Output()
        ], GcComboBoxComponent.prototype, "checkedIndicesChange", void 0);
        __decorate([
            core.ContentChildren(GcComboBoxColumnComponent)
        ], GcComboBoxComponent.prototype, "columnComponents", void 0);
        GcComboBoxComponent = GcComboBoxComponent_1 = __decorate([
            core.Component({
                selector: 'gc-combo-box',
                template: "",
                providers: [provideParent(GcComboBoxComponent_1)]
            })
        ], GcComboBoxComponent);
        return GcComboBoxComponent;
    }(GcComponents));
    var GcDateTimePickerComponent = /** @class */ (function (_super) {
        __extends(GcDateTimePickerComponent, _super);
        function GcDateTimePickerComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.selectedDateChanged = new core.EventEmitter();
            _this.selectedValueChange = new core.EventEmitter();
            return _this;
        }
        GcDateTimePickerComponent.prototype.initGcComponent = function () {
            var element = document.createElement('div');
            this._container.appendChild(element);
            this._imCtrl = new inputman.InputMan.GcDateTimePicker(element, this);
        };
        GcDateTimePickerComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            this._imCtrl.addEventListener(inputman.InputMan.GcDateTimePickerEvent.SelectedDateChanged, function (sender, eventArgs) {
                _this.selectedDateChanged.emit({ sender: sender, eArgs: eventArgs });
                _this.selectedValueChange.emit(_this._imCtrl.getValue());
            });
        };
        GcDateTimePickerComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            Property("setValue"),
            core.Input()
        ], GcDateTimePickerComponent.prototype, "selectedValue", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "maxDate", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "minDate", void 0);
        __decorate([
            Property('setPickerType'),
            core.Input()
        ], GcDateTimePickerComponent.prototype, "type", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "minuteInterval", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "secondsInterval", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "visible", void 0);
        __decorate([
            Property('showSeconds', "", false, false),
            core.Input()
        ], GcDateTimePickerComponent.prototype, "hasSeconds", void 0);
        __decorate([
            Property('showMidnightAs24', "", false, false),
            core.Input()
        ], GcDateTimePickerComponent.prototype, "showMidnightAs24", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "yearFormat", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "monthFormat", void 0);
        __decorate([
            core.Input()
        ], GcDateTimePickerComponent.prototype, "dayFormat", void 0);
        __decorate([
            core.Output()
        ], GcDateTimePickerComponent.prototype, "selectedDateChanged", void 0);
        __decorate([
            core.Output()
        ], GcDateTimePickerComponent.prototype, "selectedValueChange", void 0);
        GcDateTimePickerComponent = __decorate([
            core.Component({
                selector: 'gc-datetime-picker',
                template: ""
            })
        ], GcDateTimePickerComponent);
        return GcDateTimePickerComponent;
    }(GcComponents));
    var GcTipNotifierComponent = /** @class */ (function (_super) {
        __extends(GcTipNotifierComponent, _super);
        function GcTipNotifierComponent(ref, _parent) {
            var _this = _super.call(this, ref) || this;
            _this._parent = _parent;
            return _this;
        }
        GcTipNotifierComponent.prototype.ngAfterViewInit = function () {
            if (!this._parent || typeof this._parent !== 'object' ||
                typeof this._parent.getNestedIMControl() !== 'object') {
                return;
            }
            this._imCtrl = new inputman.InputMan.GcTipNotifier(this._parent.getNestedIMControl(), this);
            this.onInitialized.emit(this._imCtrl);
        };
        GcTipNotifierComponent.prototype.bindEvent = function () { };
        GcTipNotifierComponent.prototype.initGcComponent = function () {
        };
        GcTipNotifierComponent.prototype.onFail = function () {
            return this._imCtrl.onFail();
        };
        GcTipNotifierComponent.prototype.onSuccess = function () {
            return this._imCtrl.onSuccess();
        };
        GcTipNotifierComponent.prototype.onClear = function () {
            return this._imCtrl.onClear();
        };
        GcTipNotifierComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: GcComponents, decorators: [{ type: core.Optional }] }
        ]; };
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "direction", void 0);
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "position", void 0);
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "directionPriority", void 0);
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "template", void 0);
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "failMessage", void 0);
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "successMessage", void 0);
        __decorate([
            core.Input()
        ], GcTipNotifierComponent.prototype, "tipState", void 0);
        GcTipNotifierComponent = __decorate([
            core.Component({
                selector: 'gc-tip-notifier',
                template: ""
            }),
            __param(1, core.Optional())
        ], GcTipNotifierComponent);
        return GcTipNotifierComponent;
    }(GcComponents));
    var GcIconNotifierComponent = /** @class */ (function (_super) {
        __extends(GcIconNotifierComponent, _super);
        function GcIconNotifierComponent(ref, _parent) {
            var _this = _super.call(this, ref) || this;
            _this._parent = _parent;
            return _this;
        }
        GcIconNotifierComponent.prototype.ngAfterViewInit = function () {
            if (!this._parent || typeof this._parent !== 'object' ||
                typeof this._parent.getNestedIMControl() !== 'object') {
                return;
            }
            this._imCtrl = new inputman.InputMan.GcIconNotifier(this._parent.getNestedIMControl(), this);
            this.onInitialized.emit(this._imCtrl);
        };
        GcIconNotifierComponent.prototype.bindEvent = function () { };
        GcIconNotifierComponent.prototype.initGcComponent = function () {
        };
        GcIconNotifierComponent.prototype.onFail = function () {
            return this._imCtrl.onFail();
        };
        GcIconNotifierComponent.prototype.onSuccess = function () {
            return this._imCtrl.onSuccess();
        };
        GcIconNotifierComponent.prototype.onClear = function () {
            return this._imCtrl.onClear();
        };
        GcIconNotifierComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: GcComponents, decorators: [{ type: core.Optional }] }
        ]; };
        __decorate([
            core.Input()
        ], GcIconNotifierComponent.prototype, "direction", void 0);
        __decorate([
            Property('setFailIconSrc'),
            core.Input()
        ], GcIconNotifierComponent.prototype, "failIcon", void 0);
        __decorate([
            Property('setSuccessIconSrc'),
            core.Input()
        ], GcIconNotifierComponent.prototype, "successIcon", void 0);
        __decorate([
            core.Input()
        ], GcIconNotifierComponent.prototype, "failMessage", void 0);
        __decorate([
            core.Input()
        ], GcIconNotifierComponent.prototype, "successMessage", void 0);
        GcIconNotifierComponent = __decorate([
            core.Component({
                selector: 'gc-icon-notifier',
                template: ""
            }),
            __param(1, core.Optional())
        ], GcIconNotifierComponent);
        return GcIconNotifierComponent;
    }(GcComponents));
    var GcMultilineTextBoxComponent = /** @class */ (function (_super) {
        __extends(GcMultilineTextBoxComponent, _super);
        function GcMultilineTextBoxComponent(ref) {
            var _this = _super.call(this, ref) || this;
            _this.onEditStatusChanged = new core.EventEmitter();
            _this.onInvalidInput = new core.EventEmitter();
            _this.onKeyExit = new core.EventEmitter();
            _this.onTextChanged = new core.EventEmitter();
            _this.onIMEReadingStringOutput = new core.EventEmitter();
            _this.textChange = new core.EventEmitter();
            // For V2.1 Compatibility, we have to keep this property or event
            _this.imeReadingStringChange = new core.EventEmitter();
            return _this;
        }
        GcMultilineTextBoxComponent_1 = GcMultilineTextBoxComponent;
        GcMultilineTextBoxComponent.prototype.initGcComponent = function () {
            var element = document.createElement('textarea');
            this._container.appendChild(element);
            this["IMEReadingStringAppend"] = this.imeReadingStringAppend;
            this["IMEReadingStringKanaMode"] = this.imeReadingStringKanaMode;
            this["IMEReadingStringEnableAlphabetReadingMapping"] = this.imeReadingStringEnableAlphabetReadingMapping;
            this._imCtrl = new inputman.InputMan.GcMultiLineTextBox(element, this);
        };
        GcMultilineTextBoxComponent.prototype.bindEvent = function () {
            var _this = this;
            if (!this._imCtrl) {
                return;
            }
            _super.prototype.bindEvent.call(this);
            this._imCtrl.onIMEReadingStringOutput(function (eventArgs) {
                _this.onIMEReadingStringOutput.emit(eventArgs);
                _this.imeReadingStringChange.emit(_this._imCtrl.getIMEReadingString());
            });
        };
        var GcMultilineTextBoxComponent_1;
        GcMultilineTextBoxComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "countWrappedLine", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "lengthAsByte", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "maxLength", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "maxLineCount", void 0);
        __decorate([
            core.Input(),
            Property("setIMEReadingStringKanaMode")
        ], GcMultilineTextBoxComponent.prototype, "imeReadingStringKanaMode", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "scrollBarMode", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "scrollBars", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "wordWrap", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "acceptsReturn", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "acceptsTab", void 0);
        __decorate([
            core.Input(),
            Property("setIMEReadingStringAppend")
        ], GcMultilineTextBoxComponent.prototype, "imeReadingStringAppend", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "height", void 0);
        __decorate([
            core.Input(),
            Property("setIMEReadingStringEnableAlphabetReadingMapping")
        ], GcMultilineTextBoxComponent.prototype, "imeReadingStringEnableAlphabetReadingMapping", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "exitOnLastChar", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "highlightText", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "format", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "autoConvert", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "text", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "lines", void 0);
        __decorate([
            core.Input()
        ], GcMultilineTextBoxComponent.prototype, "imeReadingString", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "onEditStatusChanged", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "onInvalidInput", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "onKeyExit", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "onTextChanged", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "onIMEReadingStringOutput", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "textChange", void 0);
        __decorate([
            core.Output()
        ], GcMultilineTextBoxComponent.prototype, "imeReadingStringChange", void 0);
        GcMultilineTextBoxComponent = GcMultilineTextBoxComponent_1 = __decorate([
            core.Component({
                selector: 'gc-multiline-textbox',
                template: "",
                providers: [provideParent(GcMultilineTextBoxComponent_1)]
            })
        ], GcMultilineTextBoxComponent);
        return GcMultilineTextBoxComponent;
    }(GcInputManBaseComponent));

    /**
     *  Declare & add export modules
     */
    var InputManModule = /** @class */ (function () {
        function InputManModule() {
        }
        InputManModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule,
                    forms.FormsModule
                ],
                declarations: [
                    GcMaskComponent,
                    GcTextBoxComponent,
                    GcCalendarComponent,
                    GcNumberComponent,
                    GcDateTimeComponent,
                    GcListBoxComponent,
                    GcComboBoxComponent,
                    GcDateTimePickerComponent,
                    GcTipNotifierComponent,
                    GcIconNotifierComponent,
                    GcMultilineTextBoxComponent,
                    GcComboBoxColumnComponent,
                    GcListBoxColumnComponent
                ],
                exports: [
                    GcMaskComponent,
                    GcTextBoxComponent,
                    GcCalendarComponent,
                    GcNumberComponent,
                    GcDateTimeComponent,
                    GcListBoxComponent,
                    GcComboBoxComponent,
                    GcDateTimePickerComponent,
                    GcTipNotifierComponent,
                    GcIconNotifierComponent,
                    GcMultilineTextBoxComponent,
                    GcComboBoxColumnComponent,
                    GcListBoxColumnComponent
                ]
            })
        ], InputManModule);
        return InputManModule;
    }());

    exports.GcCalendarComponent = GcCalendarComponent;
    exports.GcComboBoxColumnComponent = GcComboBoxColumnComponent;
    exports.GcComboBoxComponent = GcComboBoxComponent;
    exports.GcComponents = GcComponents;
    exports.GcDateTimeComponent = GcDateTimeComponent;
    exports.GcDateTimePickerComponent = GcDateTimePickerComponent;
    exports.GcIconNotifierComponent = GcIconNotifierComponent;
    exports.GcInputManBaseComponent = GcInputManBaseComponent;
    exports.GcListBoxColumnComponent = GcListBoxColumnComponent;
    exports.GcListBoxComponent = GcListBoxComponent;
    exports.GcMaskComponent = GcMaskComponent;
    exports.GcMultilineTextBoxComponent = GcMultilineTextBoxComponent;
    exports.GcNumberComponent = GcNumberComponent;
    exports.GcTextBoxComponent = GcTextBoxComponent;
    exports.GcTipNotifierComponent = GcTipNotifierComponent;
    exports.InputManModule = InputManModule;
    exports.Property = Property;
    exports.provideParent = provideParent;
    exports.ɵ0 = ɵ0;
    exports.ɵ1 = ɵ1;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=grapecity-inputman.angular.umd.js.map
